using Lucene.Linq.Mapping;
using Lucene.Linq.Search;

namespace Lucene.Linq.VSTests.DatabaseIntegrations.CodeFirst
{
    [Document]
    public class Customer : IIndexable
    {

        #region Properties

        [Field(FieldIndex.Tokenized, FieldStore.Yes)]
        public string CustomerID
        {
            get;
            set;
        }

        [Field(FieldIndex.Tokenized, FieldStore.Yes, IsDefault = true)]
        public string CompanyName
        {
            get;
            set;
        }

        [Field(FieldIndex.Tokenized, FieldStore.Yes, Name = "ContactName")]
        public string ContactName
        {
            get;
            set;
        }

        [Field(FieldIndex.Tokenized, FieldStore.Yes)]
        public string ContactTitle
        {
            get;
            set;
        }

        public string Address
        {
            get;
            set;
        }

        public string City
        {
            get;
            set;
        }

        public string Region
        {
            get;
            set;
        }

        public string PostalCode
        {
            get;
            set;
        }

        public string Country
        {
            get;
            set;
        }

        public string Phone
        {
            get;
            set;
        }

        public string Fax
        {
            get;
            set;
        }

        #endregion
    }
}