﻿//====================================================================
// Author: Jason Plante
// Date Created: 29 October 2007
// LINQ to Lucene: Copyright (c) 2007.  All rights reserved.
//====================================================================

using Lucene.Linq.Mapping;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Lucene.Linq.VSTests.Mapping
{
    /// <summary>
    /// TODO:This is a test class for DocumentAttribute and is intended to contain all DocumentAttribute Unit Tests
    ///</summary>
    [TestClass]
    public class TestDocumentAttribute
    {
        #region Nested type: SampleClass

        /// <summary>
        /// Used to provide a sample-class for test that uses the DocumentAttribute type
        /// </summary>
        [Document(Name = "MyClass")]
        private class SampleClass
        {
            [Field(FieldIndex.UnTokenized, FieldStore.No, Name = "Keyword")]
            public string Id { get; set; }

            [Field(FieldIndex.Tokenized, FieldStore.Yes)]
            public string Name { get; set; }

            [Field(FieldIndex.No, FieldStore.Yes)]
            public string Value { get; set; }
        }

        #endregion
    }
}