﻿using System.Linq.Expressions;

namespace Lucene.Linq.Expressions
{
    internal class Replacer : LuceneExpressionVisitor
    {
        private Expression _replaceWith;
        private Expression _searchFor;

        internal Expression Replace(Expression expression, Expression searchFor, Expression replaceWith)
        {
            _searchFor = searchFor;
            _replaceWith = replaceWith;

            return Visit(expression);
        }

        protected override Expression Visit(Expression exp)
        {
            return exp == _searchFor ? _replaceWith : base.Visit(exp);
        }
    }
}